<template>
  <a-form :form="form" @submit="handleSubmit" class="person-form">
    <transition name="showInfo">
      <a-alert
        v-if="notification"
        :type="notification.type"
        style="margin-bottom: 8px"
      >
        <template slot="message">
          {{ notification.message }}
        </template>
      </a-alert>
    </transition>

    <a-form-item :required="true" v-bind="formItemLayout" label="氏名" style="margin-bottom:0;">
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(50% - 5px)' }"
      >
        <a-input
          v-decorator="[
            'firstNameKanji',
            {
              rules: [{ validator: validateFirstNameKanji }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.firstNameKanji
            }
          ]"
          placeholder="高橋"
        />
      </a-form-item>
      <span
        :style="{
          display: 'inline-block',
          width: '10px',
          textAlign: 'center'
        }"
      />
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(50% - 5px)' }"
      >
        <a-input
          v-decorator="[
            'lastNameKanji',
            {
              rules: [{ validator: validateLastNameKanji }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.lastNameKanji
            }
          ]"
          placeholder="幸雄"
        />
      </a-form-item>
    </a-form-item>

    <!-- xx -->
    <a-form-item
      v-bind="formItemLayout"
      label="氏名（フリガナ）"
      style="margin-bottom:0;"
    >
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(50% - 5px)' }"
      >
        <a-input
          v-decorator="[
            'firstNameFurigana',
            {
              rules: [{ validator: validateFirstNameFurigana }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.firstNameFurigana
            }
          ]"
          placeholder="タカハシ"
        />
      </a-form-item>
      <span
        :style="{
          display: 'inline-block',
          width: '10px',
          textAlign: 'center'
        }"
      />
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(50% - 5px)' }"
      >
        <a-input
          v-decorator="[
            'lastNameFurigana',
            {
              rules: [{ validator: validateLastNameFurigana }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.lastNameFurigana
            }
          ]"
          placeholder="ユキオ"
        />
      </a-form-item>
    </a-form-item>

    <!-- yy -->
    <a-row v-if="showCheckBox" style="margin-bottom: 24px;">
      <a-col :span="16" :offset="8">
        <a-checkbox @change="onCheckBoxChange">
          同上 <br>
          上記住所と同じ場合はチェックを入れてください。
        </a-checkbox>
      </a-col>
    </a-row>

    <!-- xx -->
    <a-form-item
      v-bind="formItemLayout"
      :required="true"
      label="郵便番号"
      style="margin-bottom:0;"
    >
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(100% - 188px)' }"
      >
        <a-input
          v-decorator="[
            'postCodeBilling',
            {
              rules: [{ validator: validatePostCode }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.postCodeBilling
            }
          ]"
          placeholder="[例] 1631435"
          autocomplete="off"
        />
        <span slot="help" v-if="noPostCode" class="text-danger">該当する住所がありません。</span>
      </a-form-item>
      <span
        :style="{
          display: 'inline-block',
          width: '8px',
          textAlign: 'center'
        }"
      />
      <a-button
        :style="{ display: 'inline-block', width: '180px' }"
        @click="generateStateCity"
        type="primary"
      >
        郵便番号から住所を検索
      </a-button>
    </a-form-item>

    <a-form-item
      v-bind="formItemLayout"
      :required="true"
      label="住所"
    >
      <a-select
        v-decorator="[
          'stateCityBilling',
          {
            rules: [{
              required: true,
              message: '都道府県を選択してください'
            }],
            initialValue: (user.stateCityBilling && user.stateCityBilling[0]) || undefined,
            validateTrigger: ['change']
          }
        ]"
        :get-popup-container="triggerNode => triggerNode.parentNode"
        @change="stateChangeHanlde"
        class="w-100"
        placeholder="都道府県"
      >
        <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />
        <a-select-option
          v-for="item in states"
          :key="item"
        >
          {{ item }}
        </a-select-option>
      </a-select>
    </a-form-item>

    <a-form-item v-bind="formItemLayout" label=" ">
      <a-select
        v-decorator="[
          'address1Billing',
          {
            rules: [{ validator: validateAddress1 }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.address1Billing || undefined
          }
        ]"
        :get-popup-container="triggerNode => triggerNode.parentNode"
        class="w-100"
        placeholder="市区町村"
      >
        <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />
        <a-select-option
          v-for="city in mapCitiesByState"
          :key="city"
        >
          {{ city }}
        </a-select-option>
      </a-select>
    </a-form-item>
    <a-form-item v-bind="formItemLayout" label=" ">
      <a-input
        v-decorator="[
          'address2Billing',
          {
            rules: [{ validator: validateAddress2 }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.address2Billing
          }
        ]"
        type="text"
        placeholder="[例] 西新宿3-20-2 東京オペラシティタワー36F"
        autocomplete="off"
      />
    </a-form-item>
    <!-- xxx -->

    <a-form-item v-bind="formItemLayout" label="部署名">
      <a-input
        v-decorator="[
          'deparmentName',
          {
            rules: [{ validator: validateDeparmentName }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.deparmentName
          }
        ]"
      />
    </a-form-item>
    <a-form-item v-bind="formItemLayout" label="役職名">
      <a-input
        v-decorator="[
          'title',
          {
            rules: [{ validator: validateTitle }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.title
          }
        ]"
      />
    </a-form-item>

    <a-form-item class="mb-none">
      <slot name="rules" />
    </a-form-item>

    <div v-if="showSubmit" style="text-align: right;">
      <a-button :loading="saving" type="primary" html-type="submit">
        更新する
      </a-button>
    </div>
  </a-form>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import { timer } from 'rxjs'

export default {
  name: 'BillingForm',
  props: {
    showSubmit: {
      type: Boolean,
      default: false
    },
    showCheckBox: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      form: this.$form.createForm(this),
      tailFormItemLayout: {
        colon: false,
        labelCol: {
          xs: { span: 24 },
          sm: { span: 8 }
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 }
        }
      },

      formItemLayout: {
        colon: false,
        labelCol: {
          xs: { span: 24 },
          sm: { span: 8 }
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 }
        }
      },
      noPostCode: false,
      saving: false,
      notification: null,
      pickState: ''
    }
  },
  computed: {
    ...mapGetters('auth', ['userInfo']),
    ...mapGetters('resources', ['states', 'getCitiesByState']),
    mapCitiesByState () {
      if (!this.pickState) { return [] }
      return this.getCitiesByState(this.pickState).map(item => item.cityName)
    },
    user () {
      return this.userInfo || {}
    }
  },
  methods: {
    ...mapActions('auth', ['updateUserInfo']),
    validateFirstNameFurigana (rule, value, callback) {
      if (value && value.length > 50) {
        return callback(new Error('名字を50文字まで入力してください'))
      }

      // https://gist.github.com/terrancesnyder/1345094
      // Regex for matching Hirgana or Katakana
      if (value && !this.isKana(value)) {
        return callback(new Error('名字（フリガナ）を入力してください。'))
      }

      callback()
    },
    validateLastNameFurigana (rule, value, callback) {
      if (value && value.length > 50) {
        return callback(new Error('名字を50文字まで入力してください'))
      }

      if (value && !this.isKana(value)) {
        return callback(new Error('名前（フリガナ）を入力してください。'))
      }
      callback()
    },
    validateFirstNameKanji (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(new Error('名字を入力してください'))
      }

      if (value.length > 50) {
        return callback(new Error('名字を50文字まで入力してください'))
      }
      callback()
    },
    validateLastNameKanji (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(new Error('名前を入力してください。'))
      }

      if (value.length > 50) {
        return callback(new Error('名字を50文字まで入力してください'))
      }
      callback()
    },

    validateDeparmentName (rule, value, callback) {
      if (value && value.length > 50) {
        return callback(new Error('部署名を50文字まで入力してください'))
      }
      callback()
    },
    validateTitle (rule, value, callback) {
      if (value && value.length > 50) {
        return callback(new Error('役職名を50文字まで入力してください'))
      }
      callback()
    },

    // TODO, need move to utils
    isKana (value) {
      const reg = /^([ァ-ヶー]+)$/
      return reg.test(value)
    },

    isNumber (value) {
      return !isNaN(value)
    },
    handleSubmit (e) {
      e.preventDefault()
      this.form.validateFields(async (err, values) => {
        if (!err) {
          this.saving = true
          try {
            await this.updateUserInfo(values)
            this.setInfo({
              type: 'info',
              message: '情報を変更しました'
            })
          } catch (error) {
            this.setInfo({
              type: 'error',
              message: 'エラーが起こりました。後でやり直してください' || error
            })
          }
          this.saving = false
        }
      })
    },
    setInfo (notification, t = 2000) {
      this.notification = notification

      // auto hide message
      this.$subscribeTo(timer(t), () => {
        this.notification = null
      })
    },

    validatePostCode (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(
          new Error('数値のみ、ハイフン(-)無しの7桁の番号を入力してださい')
        )
      }

      if (value.length > 7) {
        return callback(
          new Error('数値のみ、ハイフン(-)無しの7桁の番号を入力してださい')
        )
      }

      if (value && !this.isNumber(value)) {
        return callback(
          new Error('数値のみ、ハイフン(-)無しの7桁の番号を入力してださい11')
        )
      }
      this.noPostCode = false
      callback()
    },

    validateAddress1 (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(new Error('市区町村を入力してください'))
      }

      if (value.length > 250) {
        return callback(new Error('住所を250文字まで入力してください'))
      }

      callback()
    },
    validateAddress2 (rule, value, callback) {
      if (value && value.length > 250) {
        return callback(new Error('建物名を250文字まで入力してください'))
      }
      callback()
    },
    generateStateCity () {
      const code = this.form.getFieldValue('postCodeBilling') || ''
      if (code.toString().length === 7) {
        const preCode = code.substr(0, 3)
        const subCode = code.substr(3)

        fetch(
          `https://madefor.github.io/postal-code-api/api/v1/${preCode}/${subCode}.json`
        )
          .then(response => response.json())
          .then((results) => {
            const addressNode = results.data[0]
            if (addressNode) {
              const {
                prefecture,
                address1,
                address2
              } = addressNode.ja
              const payload = {
                state: prefecture,
                address: address1,
                detail: address2
              }
              this.onSetStateCity(payload)
            }
          })
          .catch(() => {
            this.noPostCode = true
          })
      }
    },
    onSetStateCity (payload) {
      this.form.setFieldsValue({ stateCityBilling: payload.state })
      this.pickState = payload.state
      if (payload.address) {
        this.form.setFieldsValue({ address1Billing: payload.address })
      }
      if (payload.detail) {
        this.form.setFieldsValue({ address2Billing: payload.detail })
      }
    },
    setCompanyInfoToBillingForm (companyInfo = {}) {
      this.form.setFieldsValue(companyInfo)
    },
    onCheckBoxChange (e) {
      this.$emit('onCheckBoxChange', e)
    },
    stateChangeHanlde (state) {
      this.pickState = state
      this.form.setFieldsValue({ address1Billing: null })
    }
  }
}
</script>

<style lang="less">
.person-form {
  .label {
    font-size: 14px;
    &::after {
      content: ' ';
      text-align: right;
    }
  }

  .avatar-uploader {
    .ant-upload.ant-upload-select-picture-card {
      border-radius: 50% !important;
      img {
        width: 160px;
        height: 160px;
        border-radius: 50%;
        overflow: hidden;
      }
    }
    .ant-upload {
      width: 160px;
      height: 160px;
    }
  }
}
</style>
